Data Structures | Enumerations | Functions | Variables

# goal_gui.cpp File Reference

GUI for goals. More...

`#include "stdafx.h"`
`#include "industry.h"`
`#include "town.h"`
`#include "window_gui.h"`
`#include "strings_func.h"`
`#include "date_func.h"`
`#include "viewport_func.h"`
`#include "gui.h"`
`#include "goal_base.h"`
`#include "core/geometry_func.hpp"`
`#include "company_func.h"`
`#include "company_base.h"`
`#include "story_base.h"`
`#include "command_func.h"`
`#include "widgets/goal_widget.h"`
`#include "table/strings.h"`

Go to the source code of this file.

## Data Structures
struct | GoalListWindow
| Window for displaying goals. More...
struct | GoalQuestionWindow
| Ask a question about a goal. More...
## Enumerations
enum | GoalColumn { GC_GOAL = 0, GC_PROGRESS }
| Goal list columns. More...
## Functions
void | ShowGoalsList (CompanyID company)
| Open a goal list window.
void | ShowGoalQuestion (uint16 id, byte type, uint32 button_mask, const char *question)
| Display a goal question.
## Variables
static const NWidgetPart | _nested_goals_list_widgets []
| Widgets of the GoalListWindow.
static WindowDesc | _goals_list_desc (WDP_AUTO,"list_goals", 500, 127, WC_GOALS_LIST, WC_NONE, 0, _nested_goals_list_widgets, lengthof(_nested_goals_list_widgets))
static const NWidgetPart | _nested_goal_question_widgets []
| Widgets of the goal question window.
static WindowDesc | _goal_question_list_desc (WDP_CENTER, NULL, 0, 0, WC_GOAL_QUESTION, WC_NONE, WDF_CONSTRUCTION, _nested_goal_question_widgets, lengthof(_nested_goal_question_widgets))

## Detailed Description

GUI for goals.

Definition in file goal_gui.cpp.

## Enumeration Type Documentation

enum GoalColumn

Goal list columns.

Enumerator:

  GC_GOAL | Goal text column.
  GC_PROGRESS | Goal progress column.

Definition at line 32 of file goal_gui.cpp.

## Function Documentation

void ShowGoalQuestion | ( | uint16 | id,
|  | byte | type,
|  | uint32 | button_mask,
|  | const char * | question |
| ) |  |  |

Display a goal question.

Parameters:

  | id | Window number to use.
  | type | Type of question.
  | button_mask | Buttons to display.
  | question | Question to ask.

Definition at line 486 of file goal_gui.cpp.

Referenced by CmdGoalQuestion().

void ShowGoalsList | ( | CompanyID | company | ) |

Open a goal list window.

Parameters:

  | company | Company to display the goals for, use INVALID_COMPANY to display global goals.

Definition at line 348 of file goal_gui.cpp.

References INVALID_COMPANY, and Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_company_pool >::IsValidID().

Referenced by MenuClickGoal(), MainToolbarWindow::OnHotkey(), and StoryBookWindow::OnPageElementClick().

## Variable Documentation

const NWidgetPart _nested_goal_question_widgets[]`[static]`

Initial value:

     {
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_CLOSEBOX, COLOUR_LIGHT_BLUE),
        NWidget(WWT_CAPTION, COLOUR_LIGHT_BLUE, WID_GQ_CAPTION), SetDataTip(STR_WHITE_STRING, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
      EndContainer(),
      NWidget(WWT_PANEL, COLOUR_LIGHT_BLUE),
        NWidget(WWT_EMPTY, INVALID_COLOUR, WID_GQ_QUESTION), SetMinimalSize(300, 0), SetPadding(8, 8, 8, 8), SetFill(1, 0),
        NWidget(NWID_SELECTION, INVALID_COLOUR, WID_GQ_BUTTONS),
          NWidget(NWID_HORIZONTAL, NC_EQUALSIZE), SetPIP(85, 10, 85),
            NWidget(WWT_PUSHTXTBTN, COLOUR_LIGHT_BLUE, WID_GQ_BUTTON_1), SetDataTip(STR_BLACK_STRING, STR_NULL), SetFill(1, 0),
          EndContainer(),
          NWidget(NWID_HORIZONTAL, NC_EQUALSIZE), SetPIP(65, 10, 65),
            NWidget(WWT_PUSHTXTBTN, COLOUR_LIGHT_BLUE, WID_GQ_BUTTON_1), SetDataTip(STR_BLACK_STRING, STR_NULL), SetFill(1, 0),
            NWidget(WWT_PUSHTXTBTN, COLOUR_LIGHT_BLUE, WID_GQ_BUTTON_2), SetDataTip(STR_BLACK_STRING, STR_NULL), SetFill(1, 0),
          EndContainer(),
          NWidget(NWID_HORIZONTAL, NC_EQUALSIZE), SetPIP(25, 10, 25),
            NWidget(WWT_PUSHTXTBTN, COLOUR_LIGHT_BLUE, WID_GQ_BUTTON_1), SetDataTip(STR_BLACK_STRING, STR_NULL), SetFill(1, 0),
            NWidget(WWT_PUSHTXTBTN, COLOUR_LIGHT_BLUE, WID_GQ_BUTTON_2), SetDataTip(STR_BLACK_STRING, STR_NULL), SetFill(1, 0),
            NWidget(WWT_PUSHTXTBTN, COLOUR_LIGHT_BLUE, WID_GQ_BUTTON_3), SetDataTip(STR_BLACK_STRING, STR_NULL), SetFill(1, 0),
          EndContainer(),
        EndContainer(),
        NWidget(NWID_SPACER), SetMinimalSize(0, 8),
      EndContainer(),
    }

Widgets of the goal question window.

Definition at line 447 of file goal_gui.cpp.

const NWidgetPart _nested_goals_list_widgets[]`[static]`

Initial value:

     {
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_CLOSEBOX, COLOUR_BROWN),
        NWidget(WWT_CAPTION, COLOUR_BROWN, WID_GOAL_CAPTION), SetDataTip(STR_JUST_STRING, STR_TOOLTIP_WINDOW_TITLE_DRAG_THIS),
        NWidget(WWT_SHADEBOX, COLOUR_BROWN),
        NWidget(WWT_DEFSIZEBOX, COLOUR_BROWN),
        NWidget(WWT_STICKYBOX, COLOUR_BROWN),
      EndContainer(),
      NWidget(NWID_HORIZONTAL),
        NWidget(WWT_PANEL, COLOUR_BROWN), SetDataTip(0x0, STR_GOALS_TOOLTIP_CLICK_ON_SERVICE_TO_CENTER), SetScrollbar(WID_GOAL_SCROLLBAR),
          NWidget(WWT_EMPTY, COLOUR_GREY, WID_GOAL_LIST), SetResize(1, 1), SetMinimalTextLines(2, 0), SetFill(1, 1), SetPadding(WD_FRAMERECT_TOP, 2, WD_FRAMETEXT_BOTTOM, 2),
        EndContainer(),
        NWidget(NWID_VERTICAL),
          NWidget(NWID_VSCROLLBAR, COLOUR_BROWN, WID_GOAL_SCROLLBAR),
          NWidget(WWT_RESIZEBOX, COLOUR_BROWN),
        EndContainer(),
      EndContainer(),
    }

Widgets of the GoalListWindow.

Definition at line 318 of file goal_gui.cpp.